		icl		'system.inc'

siov = $e459
		
		org		$2000

;=========================================================================		
.proc main
		;download first half of control page
		mva		#'R' dcomnd
		mva		#2 dunit
		mwa		#buffer dbuflo
		mwa		#$0080 dbytlo
		mwa		#$0800 daux1
		mva		#$40 dstats
		jsr		siov

		;patch in copy code
		ldx		#[.len patch]
		mva:rne	0+[.adr patch]-1,x buffer+$20,x-
		
		;patch in command as 'Q'
		mwa		#patch buffer+$0D

		;upload code
		mva		#'W' dcomnd
		mva		#$80 dstats
		jsr		siov
		
		;download drive code
		mwa		#$2800 dbuflo
		mva		#'Q' dcomnd
		
read_loop:
		mva		#$40 dstats
		jsr		siov

		lda		dbuflo
		eor		#$80
		sta		dbuflo
		bmi		read_loop
		
		inc		dbufhi
		lda		dbufhi
		cmp		#$40
		bcc		read_loop
		
		;write ROM image
		mwa		#filename icbal+$10
		mva		#8 icax1+$10
		mva		#CIOCmdOpen iccmd+$10
		ldx		#$10
		jsr		ciov
		
		mva		#CIOCmdPutChars iccmd+$10
		mwa		#buffer icbal+$10
		mwa		#$1800 icbll+$10
		jsr		ciov
		
		mva		#CIOCmdClose iccmd+$10
		jsr		ciov
		
		rts
		
filename:
		dta		'D1:HAPPY810.EPR',$9B
.endp

;=========================================================================
		org		$0821,*

.proc patch
		ldx		#0
copy_loop:
		lda		$1ff8
banksw_ptr = *-2
		lda		$1400,x
read_ptr = *-2
		sta		$80,x
		inx
		bpl		copy_loop
		
		lda		read_ptr
		eor		#$80
		sta		read_ptr
		bmi		finish
		
		inc		read_ptr+1
		lda		read_ptr+1
		cmp		#$20
		bcc		finish
		lda		#$14
		sta		read_ptr+1
		inc		banksw_ptr
		
finish:
		lda		$1ff8
		jmp		$1951
.endp

;=========================================================================

		org		$2800
buffer:

		run		main
